<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
<?xbl href="bindings.xml"?>
<html><head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>X-Smiles.org</title>

<link href="xsmiles_style.css" type="text/css" rel="stylesheet">
<link href="xsmiles_style.html" type="text/css" rel="stylesheet">
<style type="text/css">
					td.nav, table.nav, tr.nav,td.contentarea {vertical-align: top; border-width:0px;}
				</style><!--NOTE: THIS FILE IS AUTOMATICALLY GENERATED BY XSL, DO NOT EDIT BY HAND. EDIT FEATURES.XML INSTEAD AND RUN 'build.sh sitedoc--></head><body>
<img alt="X-SMILES.ORG" src="xsmiles.gif"><table class="nav">
<tbody><tr class="nav">
<td class="nav" style="vertical-align: top; width: 100pt;">
<div id="navbar" class="navbar">
     <div>
     <p id="link-xsmiles" class="link">
      <a class="linkmain" href="index.html">X-Smiles</a>
     </p>
     <p id="link-objectives" class="link">
      <a class="linkmain" href="xsmiles_objectives.html">Objectives</a>
     </p>
     <p id="link-contributors" class="link">
      <a class="linkmain"  href="contributors.html">Contributors</a>
     </p>
     <p id="link-screenshots" class="link">
      <a class="linkmain" href="screenshots.html">Screenshots</a>
     </p>
     <p id="link-downloads" class="link">
      <a class="linkmain" href="download.html">Download</a>
     </p>
     <p id="link-documents" class="link">  
      <a class="linkmain">Documents</a>
      <a class="linksub1" href="xsmiles_features.html">Features</a> 
      <a class="linksub1" href="xsmiles_installation.html">Installation</a>
      <a class="linksub1" href="platforms.html">Platforms</a>
      <a class="linksub1" href="xsmiles_faq.html">FAQ</a>
      <a class="linksub1" href="xsmiles_test.html">Testimonials</a>
     </p>
     <p id="link-developers" class="link">
      <a class="linkmain">Developer Area</a>
      <a class="linksub1" href="participate.html">Participating</a>
      <a class="linksub1" href="techspec.html">Technical Spec</a>
      <a class="linksub1" href="xsmiles_compiling.html">How to compile</a>
      <a class="linksub1" href="xsmiles_future.html">Projects</a>
      <a class="linksub1" href="http://www.xsmiles.org/javadoc/index.html">Javadoc</a>
      <a class="linksub1" href="cvs.html">CVS access</a>
      <a class="linksub1" href="xsmiles_smil.html">SMIL package</a>
      <a class="linksub1" href="http://www.xsmiles.org/demo/demos.xhtml">Demos</a>
     </p>
     <p id="link-reading" class="link">
      <a class="linkmain">Reading</a>
      <a class="linksub1" href="presentations.html">Presentations</a>
      <a class="linksub1" href="publications.html">Publications</a>
     </p>
     <p id="link-feedback" class="link">
      <a class="linkmain">Feedback</a>
      <a class="linksub1" href="http://sourceforge.net/bugs/?group_id=18700"> Bugs</a>
      <a class="linksub1" href="xsmiles_lists.html">Mailing lists</a>
     </p>
    </div>
    </div>
</td><td class="contentarea">
<div class="contentarea">
<h1>The SMIL player</h1>
<h2>General</h2>
<p>The SMIL 2.0 player developed in the project</p>
<ul>
<li>is integrated into the X-Smiles browser</li>
<li>can be be run as a standalone player</li>
<li>can be used as a library package</li>
</ul>
<p>This page describes how to use the SMIL player in these three ways.</p>
<h2>X-Smiles browser</h2>
<p>The SMIL player is integrated into the X-Smiles browser. To install and run the browser, see <a href="xsmiles_installation.html">the installation page</a>.</p>
<p>The SMIL player in the browser can handle external links, embedded
XForms elements and embedded XSL FO, SVG and SMIL files. These features
are not available in the standalone player or library package.</p>
<h2>SMIL standalone player</h2>
<p>SMIL presentations can also be played using a standalone
application. The standalone application can only play SMIL, it cannot
play any embedded XForms elements, XSL FO or SVG files. Also, it cannot
play SMIL embedded in a SMIL file or Ogg Vorbis audio. External links
to other documents don't work.</p>
<p>The standalone application can be run from the X-Smiles package or
from the SMIL package. Note that the classpath should include
xerces.jar, xml-apis.jar, xsmiles.jar (smil.jar) and JMF. The player
uses new Xerces2 to parse the XML files and JMF2.1.1 to play audio and
video.</p>
<p>The command to run the player is</p>
<div class="code">
<code>java -classpath smil.jar;xerces.jar;xml-apis.jar fi.hut.tml.xsmiles.mlfc.smil.viewer.swing.SMILViewer</code>
</div>
<ul>
<li>To download the X-Smiles package, see <a href="download.html">the download page</a>.&nbsp;</li>
<li>To download only the SMIL package, see the end of this page.</li>
</ul>
<h2>Library package</h2>
<h3>1. General</h3>The SMIL player can also be used as a library
package for other applications. It can be used either from the X-Smiles
package or the SMIL package. <p>The library version of the player can
only play SMIL, it cannot play any embedded XForms elements, XSL FO or
SVG files. Also, it cannot play SMIL embedded in a SMIL file or Ogg
Vorbis audio. External links to other documents don't work.</p>
<p>If the SMIL player is run from the SMIL package, the classpath
should include smil.jar, xerces.jar, xml-apis.jar and JMF. Xerces2 is
used to parse the XML files and JMF to play audio and video.</p>
<p>Also, simple HTML styling can be used, see the
demo/smil/css/css.smil demo for example. To get this to work,
ss_css2.jar should be included in the classpath (jar available in the
X-Smiles release). It is a CSS2 parser developed by SteadyState.</p>
<h3>2. Example</h3>
<p>Here is a simple example, how to use the SMIL player. The classpath
should include xerces.jar, xml-apis.jar and smil.jar. Also, for audio
and video, JMF should be installed.</p>
<br>
<div class="code">
<p>
<code><font face="Courier" size="2"><font color="#ff0000">// Import the JSMILPlayer</font>
<br>import fi.hut.tml.xsmiles.mlfc.smil.viewer.swing.JSMILPlayer;<br>
<br>import javax.swing.JFrame;<br>import java.awt.BorderLayout;<br>
<br>public class SMILApp {<br>
<br>
<font color="#ff0000">&nbsp;/**&nbsp;<br>&nbsp; * Main to play a SMIL presentation.<br>&nbsp; */</font>
<br>&nbsp;public static void main(String[] args) {<br>
<br>&nbsp; String filename = null;<br>
<br>
<font color="#ff0000">&nbsp; // Get the filename</font>
<br>&nbsp; if (args.length &gt; 0) {<br>&nbsp;&nbsp;&nbsp; filename = args[0];<br>&nbsp; } else<br>&nbsp;&nbsp;&nbsp; filename = "d:/source/xsmiles/demo/smil/ahma/ahma.smil";&nbsp;<br>
<br>&nbsp; System.out.println("SMILApp playing '"+filename);<br>
<br>
<font color="#ff0000">&nbsp; // Create the SMIL player</font>
<br>&nbsp; JSMILPlayer smil = new JSMILPlayer();<br>
<br>
<font color="#ff0000">&nbsp; // Initialize with the filename (could also be URL)</font>
<br>&nbsp; if (smil.init(filename) == false)<br>&nbsp;&nbsp;&nbsp; System.out.println("ERROR initializing "+filename);<br>
<br>
<font color="#ff0000">&nbsp; // Create a frame and add the SMIL component to it</font>
<br>&nbsp; JFrame frame = new JFrame("Simple SMIL player");<br>&nbsp; frame.setSize(600,400);<br>&nbsp; frame.getContentPane().add(smil, BorderLayout.CENTER);<br>&nbsp; frame.show();<br>
<br>
<font color="#ff0000">&nbsp; // Start the SMIL presentation</font>
<br>&nbsp; smil.start();<br>
<br>
<font color="#ff0000">&nbsp; // Wait for 10 seconds<br>
</font> &nbsp; try {<br>&nbsp;&nbsp;&nbsp; Thread.sleep(10000);<br>&nbsp; } catch (InterruptedException e) {<br>&nbsp; }<br>
<br>&nbsp; System.out.println("SMILApp stopping.");<br>
<br>
<font color="#ff0000">&nbsp; // Stop the SMIL presentation</font>
<br>&nbsp; smil.stop();<br>
<br>
<font color="#ff0000">&nbsp; // Remove the SMIL component from the frame</font>
<br>&nbsp; frame.removeAll();<br>&nbsp; frame.hide();<br>
<br>
<font color="#ff0000">&nbsp; // Free memory</font>
<br>&nbsp; smil.destroy();<br>
<br>
<font color="#ff0000">&nbsp; // Clear variables</font>
<br>&nbsp; frame = null;<br>&nbsp; smil = null;<br>
<br>
<font color="#ff0000">&nbsp; // Exit</font>
<br>&nbsp; System.exit(0);&nbsp;<br>&nbsp;}<br>}</font></code>
</p>
</div>
<br> 
<h2>Download the SMIL package</h2>
<p>The SMIL package can be downloaded here.</p>
<p>NOTE: This package contains only the SMIL player, not the complete
X-Smiles XML-browser. To download the complete X-Smiles browser, see <a href="download.html">the download page</a>. Also, the required XML parser, xerces.jar is not included here.</p>
<p>
<b><a href="http://www.xsmiles.org/bin/smil/smil.jar">SMIL package</a> (280 kb)</b> (For any platform with Java)</p>
<hr>
		  Copyright (c) 2000-2007 X-Smiles.org et.al.
	</div>
</td>
</tr>
</tbody></table>
</body></html>